/*
 * This file is part of ArmarX.
 *
 * Copyright (C) 2011-2016, High Performance Humanoid Technologies (H2T), Karlsruhe Institute of Technology (KIT), all rights reserved.
 *
 * ArmarX is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * ArmarX is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * @package    ArmarXCore::core
 * @author     Cedric Seehausen (usdnr at kit dot edu)
 * @date       2016
 * @copyright  http://www.gnu.org/licenses/gpl-2.0.txt
 *             GNU General Public License
 */


#pragma once

#include <QDialog>

namespace Ui
{
    class NameLocationView;
}

/**
* @class NameLocationView
* @brief View that allows to choose the name and the location of something.
*/
class NameLocationView : public QDialog
{
    Q_OBJECT

public:
    /**
    * Constructor that sets up the ui.
    */
    explicit NameLocationView(QWidget* parent = 0);

    /**
    * Destructor.
    */
    ~NameLocationView() override;

signals:
    void created(std::string name, std::string path);

private slots:
    void on_locationChooserButton_clicked();

    void on_nameLineEdit_editingFinished();

    void on_nameLineEdit_textChanged(const QString& arg1);

    void on_okButton_clicked();

    void on_cancelButton_clicked();

private:
    Ui::NameLocationView* ui;
    std::string path;
    std::string name;
};

