/*
* This file is part of ArmarX.
*
* ArmarX is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License version 2 as
* published by the Free Software Foundation.
*
* ArmarX is distributed in the hope that it will be useful, but
* WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program. If not, see <http://www.gnu.org/licenses/>.
*
* @package    ArmarX::
* @author     Mirko Waechter ( mirko.waechter at kit dot edu)
* @date       2014
* @copyright  http://www.gnu.org/licenses/gpl-2.0.txt
*             GNU General Public License
*/

#pragma once

#include <QGraphicsItem>
class QPainter;
class QGraphicsItem;
class QGraphicsView;
class QGraphicsSceneEvent;

namespace armarx
{
    enum LevelOfDetail
    {
        eFull,
        eNoSubstates,
        eHidden
    };
    class MorphingItem
    //            virtual public QGraphicsObject
    {
    public:
        MorphingItem(QGraphicsItem* derivedItem);
        static QGraphicsView* getView(QGraphicsSceneEvent* event);
        virtual LevelOfDetail getLevelOfDetail(QPainter* painter) const;
        virtual LevelOfDetail getLevelOfDetail(float levelOfDetail) const;
        virtual LevelOfDetail getLevelOfDetailByParent(QPainter* painter, MorphingItem* parent) const;
        static constexpr float hideOnHighDeZoomThreshold = 10.f;
        static constexpr float minSizeToShowSubstates = 70.f;
    private:
        QGraphicsItem* derivedItem;
    };

}

